"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = require("react");

var _clsx4 = _interopRequireDefault(require("clsx"));

var _Atoms = require("../../Atoms");

var _taurosWebUtils = require("tauros-web-utils");

var _styles = _interopRequireDefault(require("./styles"));

var _jsxRuntime = require("react/jsx-runtime");

var _excluded = ["value", "mask", "suffixes", "onChange", "onError", "InputProps", "error", "helperText", "classes", "setValue", "componentInputProps", "InputLabelProps"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

var PhoneNumberComponent = function PhoneNumberComponent(props) {
  var _clsx, _clsx2, _clsx3, _componentInputProps$2;

  var _props$value = props.value,
      value = _props$value === void 0 ? ['', ''] : _props$value,
      _props$mask = props.mask,
      mask = _props$mask === void 0 ? '00 0000 0000' : _props$mask,
      suffixes = props.suffixes,
      onChange = props.onChange,
      onError = props.onError,
      InputProps = props.InputProps,
      error = props.error,
      helperText = props.helperText,
      classesPhoneNumber = props.classes,
      setValue = props.setValue,
      componentInputProps = props.componentInputProps,
      InputLabelProps = props.InputLabelProps,
      rest = (0, _objectWithoutProperties2.default)(props, _excluded);

  var _useState = (0, _react.useState)(false),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      touched = _useState2[0],
      setTouched = _useState2[1];

  var _useState3 = (0, _react.useState)(''),
      _useState4 = (0, _slicedToArray2.default)(_useState3, 2),
      valuePhone = _useState4[0],
      setValuePhone = _useState4[1];

  var classes = (0, _styles.default)(); // Extract classes props

  var _ref = classesPhoneNumber || {},
      classesRoot = _ref.root,
      classesInputLabel = _ref.classesInputLabel,
      classesFormHelperText = _ref.classesFormHelperText; // Onchange to dropdown


  var onChangeDropdown = function onChangeDropdown(e) {
    if (onChange) onChange(e);
    if (onError) onError({
      code: '',
      msg: ''
    });
    setValue([e.target.value, value[1]]);
  }; // Onkeydown to input


  var onKeyDownInput = function onKeyDownInput(e) {
    var _componentInputProps$;

    if (InputProps !== null && InputProps !== void 0 && InputProps.readOnly || componentInputProps !== null && componentInputProps !== void 0 && (_componentInputProps$ = componentInputProps.InputProps) !== null && _componentInputProps$ !== void 0 && _componentInputProps$.readOnly) return;
    if (onError) onError({
      code: '',
      msg: ''
    }); // Input mask

    var newValue = (0, _taurosWebUtils.inputMask)(e, mask, valuePhone); // Set value formated

    setValuePhone(newValue); // Set value real

    setValue([value[0], newValue === null || newValue === void 0 ? void 0 : newValue.replace(/ /g, '')]);
  }; // Validate errors


  (0, _react.useEffect)(function () {
    // Validate required
    if ((!value[0] || !value[1]) && touched && InputProps !== null && InputProps !== void 0 && InputProps.required) {
      if (onError) onError({
        code: 'required',
        msg: 'Este campo es obligatorio'
      });
    }
  }, [touched, InputProps, value]);
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
    className: classes.root,
    children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_Atoms.Dropdown, _objectSpread({
      value: value[0],
      options: suffixes.map(function (suf) {
        return {
          value: suf,
          label: suf
        };
      }),
      classes: _objectSpread(_objectSpread({}, classesPhoneNumber), {}, {
        root: (0, _clsx4.default)((_clsx = {}, (0, _defineProperty2.default)(_clsx, classes.dropdown, true), (0, _defineProperty2.default)(_clsx, classesRoot || '', !!classesRoot), _clsx)),
        classesInputLabel: _objectSpread(_objectSpread({}, classesInputLabel), {}, {
          root: (0, _clsx4.default)((_clsx2 = {}, (0, _defineProperty2.default)(_clsx2, classes.labelDropdown, true), (0, _defineProperty2.default)(_clsx2, (classesInputLabel === null || classesInputLabel === void 0 ? void 0 : classesInputLabel.root) || '', !!(classesInputLabel !== null && classesInputLabel !== void 0 && classesInputLabel.root)), _clsx2))
        }),
        classesFormHelperText: _objectSpread(_objectSpread({}, classesFormHelperText), {}, {
          root: (0, _clsx4.default)((_clsx3 = {}, (0, _defineProperty2.default)(_clsx3, classes.helperText, true), (0, _defineProperty2.default)(_clsx3, (classesFormHelperText === null || classesFormHelperText === void 0 ? void 0 : classesFormHelperText.root) || '', !!(classesFormHelperText !== null && classesFormHelperText !== void 0 && classesFormHelperText.root)), _clsx3))
        })
      }),
      onChange: onChangeDropdown,
      withAutocomplete: true,
      onClick: function onClick() {
        return setTouched(true);
      },
      InputProps: InputProps,
      InputLabelProps: _objectSpread(_objectSpread({}, InputLabelProps), {}, {
        shrink: true
      }),
      helperText: helperText,
      error: Boolean(error)
    }, rest)), /*#__PURE__*/(0, _jsxRuntime.jsx)(_Atoms.Input, _objectSpread(_objectSpread({
      value: valuePhone,
      fullWidth: true,
      onKeyDown: onKeyDownInput,
      onClick: function onClick() {
        return setTouched(true);
      },
      error: Boolean(error)
    }, componentInputProps), {}, {
      inputProps: _objectSpread(_objectSpread({}, componentInputProps === null || componentInputProps === void 0 ? void 0 : componentInputProps.inputProps), {}, {
        maxLength: 10
      }),
      InputProps: _objectSpread(_objectSpread({}, componentInputProps === null || componentInputProps === void 0 ? void 0 : componentInputProps.InputProps), {}, {
        readOnly: (InputProps === null || InputProps === void 0 ? void 0 : InputProps.readOnly) || (componentInputProps === null || componentInputProps === void 0 ? void 0 : (_componentInputProps$2 = componentInputProps.InputProps) === null || _componentInputProps$2 === void 0 ? void 0 : _componentInputProps$2.readOnly)
      })
    }))]
  });
};

var _default = PhoneNumberComponent;
exports.default = _default;